#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

FILE *radioFileA;

static void wait()
{
    /* dummy delay ?! */
}


static void send_freq(char freq[])
{
    int i, j, frbuf;

    i = 0; /* CATѥ */
    j = 0; /* ʸѥ */

    if ( strncmp(freq, "12", 2) == 0 ) {  /* 1200MHzν */
	frbuf  = 0xc0;                /* 12  Cx ִ */
	j = 2;
	frbuf += freq[j]-'0';
    } else {                              /* 430/144MHzν */
	frbuf  = ( freq[j]-'0' ) << 4;
	++j;
	frbuf +=   freq[j]-'0';
    }
    putc(frbuf, radioFileA); wait();      /* ǽ1byte */

    ++j;
    for( i=1; i<4; ++i) {             /* Ĥ3byte */
	frbuf = (freq[j]-'0') << 4;   /* 4bit */
	++j;
	if ( freq[j] == '.' ) {
	    ++j;                      /* .ϥåפ*/
	}
	frbuf += freq[j]-'0';         /* 4bit */
	putc(frbuf, radioFileA); wait();  /* 1byteʬ */
	++j;
    }

}
    

main() {
    int dummy = 0;
    int saton = 0x0E;
    int modus = 0x01;
    int modfm = 0x08;
    int modrx = 0x17;
    int frqrx = 0x1e;
    int modtx = 0x27;
    int frqtx = 0x2e;
    int term;
    char freq[12];
    double downFreq =  437.0513;
    double upFreq   =  145.900;


    radioFileA = fopen("/dev/ttyR2", "a");
    if ( radioFileA == NULL ) {
	fprintf(stderr, "can't open /dev/ttyR2\n");
	exit(EXIT_FAILURE);
    }

/* ȥ ON */
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    fflush(radioFileA);
    sleep(1);

/*  ON */
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(saton, radioFileA);    wait();
    fflush(radioFileA);
    sleep(1);

/*  RX⡼ SET */
    putc(modfm, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(modrx, radioFileA);    wait();
    fflush(radioFileA);
    sleep(1);

/*  RXȿ */
    sprintf(freq, "%.6f", downFreq);
    term = strlen(freq);  freq[term] = '\0';
    send_freq(freq);
    putc(frqrx, radioFileA);    wait();
    fflush(radioFileA);
    sleep(1);

/*  TX⡼ SET */
    putc(modfm, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(dummy, radioFileA);    wait();
    putc(modtx, radioFileA);    wait();
    fflush(radioFileA);
    sleep(1);

/*  TXȿ SET */
    sprintf(freq, "%.6f", upFreq);
    term = strlen(freq);  freq[term] = '\0';
    send_freq(freq);
    putc(frqtx, radioFileA);    wait();
    fflush(radioFileA);

    fclose(radioFileA);

}
